Subject: Re: [PATCH 0/3]: net: dsa: mt7530: support MT7530 in the MT7621 SoC

From: Andrew Lunn <[email-masked]>
Date: Fri, 30 Nov 2018 14:37:51 +0100

> 1. TX packets are not getting an IP header checksum via the normal
>    off-loaded checksumming when in DSA mode. I have to switch off
>    NETIF_F_IP_CSUM, so the software stack generates the checksum.
>    That checksum offloading works ok when not using the 7530 DSA driver.

With some vendors MAC hardware, there is a field in the descriptor to
indicate how big a VLAN tag the frame has. The hardware can then use
this information to skip over the VLAN tags to find the IP header, and
then perform checksuming. You might be able to re-use that, consider
the DSA header as part of the VLAN header.

Other vendors, there is no way i've found to get hadware offload of
checksumming working.

    Andrew